<?php

// $Id: thebanner_class.php 5148 2012-05-07 08:18:08Z calicant $


define ("THEBANNER_DIR_NAME", "../thebanner");   // la directory radice per i banner
define ("MAX_BANNER_SIZE_BYTES", "200000");     //  massima dimensione di un banner in bytes

// l'utente privilegiato
define ("THEBANNER_SUPERUSER", "superuser");

// le azioni da compiere su una lista di banner o sul singolo banner
define ("THEBANNER_ACTION_REMOVE", "bannerRemove");
define ("THEBANNER_ACTION_ADD", "bannerAdd");
define ("THEBANNER_ACTION_STATIC", "bannerStatic");
define ("THEBANNER_ACTION_MODIFY", "bannerModify");

// codici d'errore ritornati in caso di fallita instanzione
define ("THEBANNER_ERROR_CODE_CONNH", 1);
define ("THEBANNER_ERROR_CODE_USER", 2);
define ("THEBANNER_ERROR_CODE_BANNERDIR", 3);
define ("THEBANNER_ERROR_CODE_FILESIZE", 4);

// qualche codice d'errore numerico usato dalla classe TheBanner
define("ERR_TB_CODE_WRONG_SIZE", 11);


class TheBanner {

    var     $_tb_connh;
    var     $_tb_user;  
    var     $_tb_maxsize;
    var     $_tb_last_error;
    var     $_tb_error;
    var     $_tb_error_code;
    var     $_tb_debug;
    var     $_tb_currentuser;
    var     $_tb_defaultbannerlist;
    var     $statusError;


    function TheBanner ($connh, $user) {

    $this->statusError = 0;
    $this->_tb_connh = $connh;
    $this->_tb_currentuser = $user;
    $this->_tb_maxsize = MAX_BANNER_SIZE_BYTES;
    $this->_tb_bannerdir = THEBANNER_DIR_NAME;
    $this->_tb_last_error = '';
    $this->_tb_error_code = 0;
    $this->_tb_error = false;

    $this->_tb_defaultbannerlist = array (
        // standard e preesistenti
        array(468,  60),
        array(392,  72),
        array(234,  60),
        array(120, 240),
        array(125, 125),
        array(120,  90),
        array(120,  60),
        array( 88,  31),
        // IAB standard: orizzontali
        array(336, 280),
        array(300, 250),
        array(250, 250),
        array(240, 400),
        array(180, 150),
        // IAB standard: verticali
        array(180, 150),
        array(160, 600),
        array(120, 600)
    );

    // un controllo sui parametri in ingresso sulla dir di output
    if (!isset($connh) || !$connh) {
        $this->statusError = THEBANNER_ERROR_CODE_CONNH;
        return;
    }

    if (!isset($user) || trim($user) == '') {
        $this->statusError = THEBANNER_ERROR_CODE_USER;
        return;
    }

    if (!isset($this->_tb_bannerdir) || trim($this->_tb_bannerdir) == '') {
        $this->statusError = THEBANNER_ERROR_CODE_BANNERDIR;
        return;
    }

    if (!isset($this->_tb_maxsize) || $this->_tb_maxsize == 0) {
        $this->statusError = THEBANNER_ERROR_CODE_FILESIZE;
        return;
    }

    if (!file_exists($this->_tb_bannerdir))
        if (!@mkdir($this->_tb_bannerdir, 0700)) {
        $this->statusError = THEBANNER_ERROR_CODE_BANNERDIR;
        return;
        }

    } // TheBanner


function uploadBanner ($bannerList) {


    // assegnamento variabili temporanee di lingua
    $l_sending_banner = LABEL_SENDING_BANNER;
    $l_url = LABEL_URL;
    $l_alt = LABEL_ALT;
    $l_description = LABEL_DESCRIPTION;
    $l_choose_banner = LABEL_CHOOSE_BANNER;
    $l_private = LABEL_PRIVATE;
    $l_public = LABEL_PUBLIC;
    $b_send = BUTTON_SEND;
 

    echo <<< END
    <form name="fuploadbanner" action="$_SERVER[PHP_SELF]" method="POST" ENCTYPE="multipart/form-data">
    <input type="HIDDEN" name="MAX_FILE_SIZE" value="$this->_tb_maxsize">
    <input type="hidden" name="incoming" value="ok" />
END;

    $this->_output_prefs_vars($bannerList);

echo <<< END
    <table class="table_border" width="
END;
    include("include/dim_all.inc.php");
echo <<< END
    " align="CENTER" cellpadding="3" cellspacing="1" border="0">
    <tr>
    <th colspan="3" class="table_tit" align="CENTER">$l_sending_banner</th>
    </tr><tr>
    <td class="table_sez" align="CENTER">$l_url: <input class="insert_area" type="TEXT" name="bannerInfo[url]" size="30" value="http://"></td>
    <td class="table_sez" align="CENTER">$l_alt: <input class="insert_area" type="TEXT" name="bannerInfo[alt]" size="30"></td>
    <td class="table_sez" align="CENTER">$l_description: <input class="insert_area" type="TEXT" name="bannerInfo[description]" size="30"></td>
    </tr><tr>
    <td class="table_sez" align="CENTER">$l_choose_banner</td>
    <td colspan="2" class="table_sez" align="CENTER">
    Tipo:
    &nbsp;<select class="insert_area" name="bannerInfo[visibility]" size="1">
    <option SELECTED value="private">$l_private</option>
    <option value="public">$l_public</option>
    </select>
    &nbsp;&nbsp;&nbsp;
    <input class="insert_area" type="file" name="upfile" size="40" />&nbsp;&nbsp;&nbsp;&nbsp;
    <input type="SUBMIT" name="bSubmitBanner" class="button_in awesome" value="$b_send"></td>
    </tr></table></form> 
END;
} // uploadBanner



function showBannerList (&$bannerList, $resetpositionstatus) {


if ($resetpositionstatus) {
    $bannerList['position'] = 0;
    if ($this->_tb_debug)
    $this->_out_debug_msg ("sizetype changed: si resetta a 0 la posizione di navigazione"); 
}


if (!isset($bannerList['owner']) || !$bannerList['owner']) {
    $owner_w = "owner = '" . $this->_tb_currentuser . "'";
} else {
    $owner_w = '';
    if ($this->_tb_currentuser != THEBANNER_SUPERUSER)
    $bannerList['visibility'] = 'public';
}


$sizetype_w = "sizetype = '" . $bannerList['sizetype'] . "'";
$visibility_w = "visibility = '" . $bannerList['visibility'] . "'";

$prequery_count = "SELECT COUNT(id) AS banner_total FROM ";
$prequery_list = "SELECT * FROM  ";

$query_body = THEBANNER_TABLE_LIST . " WHERE " . $sizetype_w . " AND " . $visibility_w;
if ($owner_w != '')
    $query_body .= " AND " . $owner_w;

$query_order .= " ORDER by id DESC";

$dbquery = $prequery_count . $query_body;

$rowrs = $this->_tb_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_tb_connh->ErrorMsg());
$banner_total = $rowrs->fields('banner_total');

if ($banner_total)
    $s_banner_total = "(Totale: $banner_total)"; 

// eventuali spostamenti

if ($bannerList['showlimit']) {
    $position_mod = ($banner_total % $bannerList['showlimit']);
    $position_max = $banner_total - $position_mod;
    
    if (!$position_mod)
    $position_max -= $bannerList['showlimit'];

    if (isset($bannerList['navigation_init']))
    $bannerList['position'] = 0; 
    else if (isset($bannerList['navigation_forward']))
     $bannerList['position'] += $bannerList['showlimit'];   
    else if (isset($bannerList['navigation_rewind']))
     $bannerList['position'] -= $bannerList['showlimit'];   
    else if (isset($bannerList['navigation_end']))
    $bannerList['position'] = $position_max;

    // aggiustamenti
    if ($bannerList['position'] < 0)
    $bannerList['position'] = 0;

    if ($bannerList['position'] > $position_max)
    $bannerList['position'] = $position_max;
}

if ($bannerList['showlimit'] && $banner_total > $bannerList['showlimit']) {
    $navigation_panel_s =
    $this->_build_navigation_panel($bannerList['position'], $position_max, $banner_total, $bannerList['showlimit']);
    $query_limit = " LIMIT $bannerList[position], $bannerList[showlimit]";    
} else {
    $navigation_panel_s = '';
    $query_limit = '';
}


$dbquery = $prequery_list . $query_body . $query_order . $query_limit;
$rowrs = $this->_tb_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_tb_connh->ErrorMsg());

if ($this->_tb_debug)
    $this->_out_debug_msg ("query : $dbquery");

$banner_type_dir = $this->_tb_bannerdir . "/" . $this->_get_size_from_type ($bannerList['sizetype'], $ww, $hh);

// alcuni variabili per parametrizzazione lingua

$l_available_banner_list = LABEL_AVAILABLE_BANNER_LIST;

if ($this->_tb_currentuser == 'superuser')
    $size_class_note = " [".  LABEL_SIZE_NOTE . "]";
else
    $size_class_note = '';

echo <<< END
<form name="fshowbanners" action="$_SERVER[PHP_SELF]" method="POST" ENCTYPE="multipart/form-data">
<input type="hidden" name="addbanners" value="ok" />
END;
// $this->_output_prefs_vars($bannerList);
echo <<< END
<input type="hidden" name="resetpositionstatus" value="0" />
<input type="HIDDEN" name="bannerList[position]" value="$bannerList[position]">
<input type="HIDDEN" name="bannerList[showlimit]" value="$bannerList[showlimit]">
<table class="table_border" width="
END;
include("include/dim_all.inc.php");
echo <<< END
" align="CENTER" cellpadding="3" cellspacing="1" border="0">
<tr>
<th colspan="2" class="table_tit" align="CENTER">$l_available_banner_list  $s_banner_total $size_class_note</th>
</tr>
<tr>
END;

if ($this->_tb_currentuser == THEBANNER_SUPERUSER) {
    $presize = "<span onclick=\"javascript:sm();\">"; 
    $postsize = "</span>";
}
else {
    $presize = "";
    $postsize = "";
}

echo "<td class=\"table_tit\" align=\"left\">$presize" . LABEL_BANNER_SIZE . "$postsize:&nbsp";
$this->_output_sizetype_selection($bannerList['sizetype']);
echo "&nbsp;" . LABEL_TYPE . ":&nbsp;";
$this->_output_visibility_selection($bannerList['visibility']);
echo "&nbsp;" . LABEL_SHOW_BANNER_NOT_YOURS . ":&nbsp;";
$this->_output_owner_selection($bannerList['owner']);
echo
    "</td><td class=\"table_tit\" align=\"left\">" ."&nbsp;" . LABEL_BANNER_PER_PAGE .  ":&nbsp;";
$this->_output_showlimit_selection($bannerList['showlimit']);
if ($navigation_panel_s != '')
    echo "&nbsp;" . $navigation_panel_s;

echo "</td></tr>\n";


if ($rowrs->RecordCount() > 0) {

    while (!$rowrs->EOF) {
    $row = $rowrs->fields;
    $this->_output_banner_row($row, THEBANNER_ACTION_ADD, $banner_type_dir, $ww, $hh);
    $rowrs->MoveNext();
    } // while


    echo "<tr><td class=\"table_tit\" colspan=\"2\" align=\"CENTER\">\n"; 

    $nmodgroup = 0;
    $group_list = $this->_get_group_list($bannerList['sizetype']);


    $click_stuff =
    "onclick = \"var c = 0; var i; for (i = 0; i < document.forms.fshowbanners.elements.length; i++) " .
            "if (document.forms.fshowbanners.elements[i].type == 'radio') { " .
        "c++; if (c == 3) { document.forms.fshowbanners.elements[i].checked = true; break; } }" .
        "\";";

    $nmsg =
    LABEL_BANNER_ADD_TO_NEW_GROUP . " " .
    "<input size=\"10\" $click_stuff class=\"insert_area\" name=\"" .
    "bannerList[new_group_name]" . "\"> &nbsp;" .
    "<select class=\"insert_area\" size=\"1\" name=\"" . "bannerList[group_visibility]" . "\">\n" .
    "<option SELECTED value=\"private\">" . LABEL_PRIVATE . "</option>\n" .
    "<option value=\"public\">" . LABEL_PUBLIC . "</option>\n" .
    "</select>\n";


    if ($group_list->RecordCount() > 0) {

    

    $gmsg =
        LABEL_BANNER_ADD_TO_EXISTING_GROUP . " " . "<select class=\"insert_area\" size=\"1\" name=\"" . "bannerList[selected_group]" . "\">\n";

    // di default il gruppo vuoto

    $gmsg .= "<option SELECTED value=\"0\">&nbsp;&nbsp;---&nbsp;&nbsp;</option>\n"; 
    
    while (!$group_list->EOF) {
        $row = $group_list->fields;

        if ($row['visibility'] == 'public' || $row['owner'] == $this->_tb_currentuser) {
        $nmodgroup++;
        $gmsg .= "<option value=\"$row[id]\">$row[name]</option>\n";
        }       
        $group_list->MoveNext();
    } // while
    $gmsg .= "</select>\n";
    }

    echo "<input class=\"insert_area\" type=\"RADIO\" name=\"" . "bannerList[radio_mode]" .
    "\" value=\"remove_from_banner_list\">&nbsp;" . LABEL_DELETE . "&nbsp;&nbsp;" . "\n";

    if ($nmodgroup) {
    echo
        "<input CHECKED class=\"insert_area\" type=\"RADIO\" name=\"" . "bannerList[radio_mode]" .
        "\" value=\"add_to_group\">\n";
    echo $gmsg . "&nbsp;&nbsp;";
    $rcheck = '';
    }
    else $rcheck = "CHECKED";

    echo
    "<input class=\"insert_area\" $rcheck type=\"RADIO\" name=\"" . "bannerList[radio_mode]" .
        "\" value=\"create_new_group\">\n" .
    $nmsg .
    "&nbsp;&nbsp;<input class=\"button_in awesome\" type=\"SUBMIT\" name=\"bannerList[bSubmit]\" value=\"" .
        BUTTON_APPLY_CHANGES . "\">\n" .
    "</td>" .
    "</tr>\n";

} else
    echo "<tr><td colspan=\"2\" class=\"table_sez\" align=\"CENTER\">" . MSG_NO_BANNERS . "</td></tr>\n";

echo "</td>\n</tr>\n";

echo <<< END
</table>
</form>
END;
}


function showGroupList ($bannerList) {

$size = $bannerList['sizetype'];

$s_size = $this->_get_size_from_type($size, $ww, $hh);

$rowrs = $this->_get_group_list($size);
if (!$rowrs->RecordCount())
    return;

$l_group_list_for_size = LABEL_GROUP_LIST_FOR_SIZE;
$l_group_name = LABEL_GROUP_NAME;
$l_group_owner = LABEL_OWNER;
$l_group_type = LABEL_TYPE;
$l_group_n_banner = str_replace(' ', '&nbsp;', LABEL_GROUP_N_BANNER);
$l_modify = LABEL_MODIFY;
$l_delete = LABEL_DELETE;
$b_group_apply_changes = BUTTON_GROUP_APPLY_CHANGES;


echo <<< END
<form name="fgrouplist" action="$_SERVER[PHP_SELF]" method="POST" ENCTYPE="multipart/form-data">
<input type="hidden" name="grouplist" value="ok" />
END;
$this->_output_prefs_vars($bannerList);
echo <<< END
<table class="table_border" width="
END;
include("include/dim_all.inc.php");
echo <<< END
" align="CENTER" cellpadding="3" cellspacing="1" border="0">
<tr>
<th colspan="7" class="table_tit" align="CENTER">$l_group_list_for_size $s_size</th>
</tr><tr>
<th class="table_id" align="CENTER" width="40">ID</th>
<th class="table_id" align="CENTER">$l_group_name</th>
<th class="table_id" align="CENTER">$l_group_owner </th>
<th class="table_id" align="CENTER">$l_group_type </th>
<th class="table_id" align="CENTER" width="40">$l_group_n_banner</th>
<th class="table_id" align="CENTER">$l_modify</th>
<th class="table_id" align="CENTER">$l_delete </th>
</tr>
END;


$array_v = array ('public' => LABEL_PUBLIC, 'private' => LABEL_PRIVATE);


while (!$rowrs->EOF) {
    $row = $rowrs->fields;


    $smodifica =
    "<input  class=\"button_in\" type=\"SUBMIT\" name=\"" . "bGroupShow[$row[id]]" . "\" value=\"" . LABEL_GROUP_SEE . "\">";

    if ($this->_tb_currentuser == THEBANNER_SUPERUSER || $row['owner'] == $this->_tb_currentuser) {

        $visibility =
        "\n<select class=\"insert_area\" size=\"1\" name=\"bGroupVisibility[$row[id]]\">\n";

    reset($array_v);
    while (list($k, $v) = each ($array_v)) {
        $is_selected = $row['visibility'] == $k ? 'SELECTED' : '';

        $visibility .=
        "<option $is_selected value=\"" . $k . "\">" . $v . "</option>\n";
    }
    $visibility .= "</select>\n";

    $sdelete = "<input class=\"insert_area\" type=\"CHECKBOX\" name=\"" . "bGroupDelete[]" . "\" value=\"" . $row['id'] . "\">";  
    }
    // non si hanno i permessi di modificare questo gruppo
    else {
    $visibility = $array_v[$row['visibility']];
    $sdelete = " --- ";
    }

    echo
    "<tr>\n" .
    "<td class=\"table_sez\" align=\"CENTER\">" . $row['id'] . "</td>" .
    "<td class=\"table_sez\" align=\"CENTER\">" .
    $row['name'] .
    "</td>" .
    "<td class=\"table_sez\" align=\"CENTER\">" . $row['owner'] . "</td>" .
    "<td class=\"table_sez\" align=\"CENTER\">" . $visibility . "</td>" .
    "<td class=\"table_sez\" align=\"CENTER\">" . $row['totbanner'] . "</td>".
    "<td class=\"table_sez\" align=\"CENTER\">" . $smodifica . "</td>" .
    "<td class=\"table_sez\" align=\"CENTER\">" . $sdelete . "</td>" .
    "</tr>\n";

    $rowrs->MoveNext();
}

echo <<< END
<tr>
<td align="CENTER" class="button_out" colspan="7">
<input class="button_in awesome" type="SUBMIT" name="bGroupChange" value="$b_group_apply_changes">
</tr>
</table>
</form>
END;
}


function showGroupInfo ($groupid, $bannerList) {


$owner = $this->_get_group_owner_visibility_name ($groupid, $visibility, $gname);


if ($this->_tb_currentuser == THEBANNER_SUPERUSER || $owner == $this->_tb_currentuser) {

    $modify_action = THEBANNER_ACTION_REMOVE;
    $modify_button =
    "&nbsp;&nbsp;&nbsp;" .                                                                                          
    "<input class=\"button_in\" type=\"SUBMIT\" name=\"bBannerRemove\" value=\"" . BUTTON_DELETE_SELECTED_BANNER . "\">";

} else {
    $modify_action = THEBANNER_ACTION_STATIC;
    $modify_button = '';
}


$l_banner_available_to_group = LABEL_BANNER_AVAILABLE_TO_GROUP;
$l_go_to_main_panel = LABEL_GO_TO_MAIN_PANEL;

echo <<< END
<form name="fgroupinfo" action="$_SERVER[PHP_SELF]" method="POST" ENCTYPE="multipart/form-data">
<input type="hidden" name="groupinfo" value="ok" />
<input type="HIDDEN" name="bGroupShow[$groupid]" value="ok">
<input type="HIDDEN" name="groupID" value="$groupid">
END;
$this->_output_prefs_vars($bannerList);
echo <<< END
<table class="table_border" width="
END;
include("include/dim_all.inc.php");
echo <<< END
" align="CENTER" cellpadding="3" cellspacing="1" border="0">
<tr>
<th colspan="2" class="table_tit" align="CENTER">$l_banner_available_to_group "$gname"</th>
</tr>
END;

// si vedono i banner che fanno parte di questo gruppo
$dbquery = "SELECT * FROM " . THEBANNER_TABLE_RELATIONS . ", " . THEBANNER_TABLE_LIST.
    " WHERE " . THEBANNER_TABLE_RELATIONS . ".idgroup ='" . $groupid . "' AND " .
    THEBANNER_TABLE_RELATIONS . ".idbanner = " . THEBANNER_TABLE_LIST . ".id" . " ORDER BY hits DESC";  
    
    // note di contenuto per questa immagine
    $rowrs = $this->_tb_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_tb_connh->ErrorMsg());

    if ($rowrs->RecordCount() > 0) {
    $banner_type_dir = '';

    while (!$rowrs->EOF) {
        $row = $rowrs->fields;
        if ($banner_type_dir == '')
        $banner_type_dir = $this->_tb_bannerdir . '/' . $this->_get_size_from_type($row['sizetype'], $ww, $hh);
        $this->_output_banner_row($row, $modify_action, $banner_type_dir, $ww, $hh);
        $rowrs->MoveNext();
    } // while
    }
    else {
    echo
        "<tr><td colspan=\"2\" align=\"CENTER\" class=\"table_sez\">" .
         LABEL_EMPTY_GROUP . 
        "</td></tr>\n";
    $modify_button = '';
    }
echo <<< END
<tr>
<td colspan="2" class="button_out" align="CENTER">
<input class="button_in" type="SUBMIT" name="bTopanel" value="$l_go_to_main_panel">
$modify_button
</td>
</tr>
</table>
</form>
END;

} // showGroupInfo


    function showFormBannerModify ($bannerList) {

echo <<< END
<script language="Javascript" type="text/javascript">
function bm (id) {
    document.forms.fbannermodify.bannermodify.value = id;
    document.forms.fbannermodify.submit();
}
</script>
<noscript>$err_js_not_supported</noscript>
<form name="fbannermodify" action="$_SERVER[PHP_SELF]" method="POST">
<input type="hidden" name="bannermodify" value="0" />
END;

    $this->_output_prefs_vars($bannerList);
    echo "</form>";
    } // showFormBannerModify;


    function showFormSizeModify ($bannerList) {

    if ($this->_tb_currentuser != THEBANNER_SUPERUSER)
        return;

echo <<< END
<script language="Javascript" type="text/javascript">
function sm () {
    document.forms.fsizemodify.submit();
}
</script>
<noscript>$err_js_not_supported</noscript>
<form name="fsizemodify" action="$_SERVER[PHP_SELF]" method="POST">
<input type="hidden" name="sizemodify" value="ok" />
END;

    $this->_output_prefs_vars($bannerList);
    echo "</form>";
    } // showSizeModify

    function setDebug ($status) {
    
    $this->_tb_debug = $status;
    
    } // setDebug

    function _build_navigation_panel($position, $position_max, $banner_total, $showlimit) {
    
    $page_total = ceil($banner_total / $showlimit);
    $page_current = floor($position / $showlimit) + 1; 

    if (!$position) {
        $init_disabled = 'DISABLED';
        $rewind_disabled = 'DISABLED';
    }
    else {
        $init_disabled = '';
        $rewind_disabled = '';      
    }


    if ($position == $position_max) {
        $end_disabled = 'DISABLED';
        $forward_disabled = 'DISABLED';
    }
    else {
        $end_disabled = '';
        $forward_disabled = '';     
    }

    return
        "<input class=\"button_in\" $init_disabled type=\"SUBMIT\" name=\"bannerList[navigation_init]\" value=\"<<\">" . "&nbsp;" .
        "<input class=\"button_in\" $forward_disabled type=\"SUBMIT\" name=\"bannerList[navigation_forward]\" value=\">\">" . "&nbsp;" .
        "<input class=\"button_in\" $rewind_disabled type=\"SUBMIT\" name=\"bannerList[navigation_rewind]\" value=\"<\">" . "&nbsp;" .
        "<input class=\"button_in\" $end_disabled type=\"SUBMIT\" name=\"bannerList[navigation_end]\" value=\">>\">" . "&nbsp;" .
        LABEL_NAVIGATION_PAG . " $page_current / $page_total";
    } // _build_navigation_panel

    function _output_banner_row($row, $mode, $banner_type_dir, $ww, $hh) {

    $array_v = array ('public' => LABEL_PUBLIC, 'private' => LABEL_PRIVATE);
    
    if (trim($row[url]) != '' && trim($row[url]) != 'http://') {
        $url_begin  = "<a href=\"" . $row[url] . "\" target=\"_blank\">\n";
        $url_end = "</a>";
    }
    else {
        $url_begin = '';
        $url_end = '';
    }


    $bannerfile = $banner_type_dir . '/' . $row['id'] . '-' . $row['random'] . '.' . $this->_map_file_to_extension ($row['imgtype']);


    if (file_exists($bannerfile) && is_readable($bannerfile)) {
        // se abbiamo a che fare con un flash
        if ($row['imgtype'] == 4 || $row['imgtype'] == 13) {
        $include_img =
        "<object classid=\"clsid:D27CDB6E-AE6D-11cf-96B8-444553540000\" " .
        "codebase=\"http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=5,0,0,0\" width=\"$ww\" height=\"$hh\">\n" .
        "<param name=movie value=\"$bannerfile\">\n" .
        "<embed src=\"$bannerfile\" " .
        "pluginspage=\"http://www.macromedia.com/shockwave/download/index.cgi?P1_Prod_Version=ShockwaveFlash\" " .
        "type=\"application/x-shockwave-flash\" width=\"$ww\" height=\"$hh\">\n" .
        "</embed>\n" .
        "</object>\n";
        }
        else $include_img =  "<img width=\"$ww\" HEIGTH=\"$hh\" border=\"0\" alt=\"" . $row[alt] . "\" src=\"" . $bannerfile . "\" />\n";
    }
    else $include_img = LABEL_IMG_NOT_AVAILABLE;
    
    $tipovisib = $array_v[$row['visibility']];
   
    if ($mode == THEBANNER_ACTION_STATIC)
        $check_part = '';
    else
        $check_part =  "<input class=\"insert_area\" type=\"CHECKBOX\" name=\"" . $mode . "[]\" value=\"$row[id]\">";


    if (($this->_tb_currentuser == THEBANNER_SUPERUSER || $this->_tb_currentuser == $row['owner']) && $mode == THEBANNER_ACTION_ADD) {
        $link_modify_start = "<a href=\"javascript:bm($row[id]);\"";
        $link_modify_end = "</a>";
    } else {
        $link_modify_start = '';
        $link_modify_end = '';
    }


    if ($mode == THEBANNER_ACTION_MODIFY) {

        $s_visib = "<select class=\"insert_area\" size=\"1\" name=\"bannerModify[visibility]\">\n";
        $vis_type = array ('private', 'public');

        foreach ($vis_type as $currval) {
        $issel = $row['visibility'] == $currval ? 'SELECTED' : '';
        $s_visib .= "<option $issel value=\"$currval\">" . $array_v[$currval] . "</option>\n";
        }
        $s_visib .= "</select>\n";

        $s_url = "<input class=\"insert_area\" size=\"40\" name=\"bannerModify[url]\" value=\"$row[url]\">";
        $s_alt = "<input class=\"insert_area\" size=\"40\" name=\"bannerModify[alt]\" value=\"$row[alt]\">";
        $s_desc = "<input class=\"insert_area\" size=\"50\" name=\"bannerModify[description]\" value=\"$row[description]\">";
    } else {
        $s_visib = $tipovisib;
        $s_url = $row['url'];
        $s_alt = $row['alt'];
        $s_desc = $row['description'];
    }

    echo
        "<tr>\n" .
        "<td width=\"50%\" align=\"CENTER\" rowspan=\"5\" class=\"table_sez\" align=\"CENTER\">" .
        $url_begin .
        $include_img .
        $url_end .
        "</td>\n" .
        "</tr>\n" .

        "<tr>" .
        "<td class=\"button_out\" align=\"LEFT\">" .
        "$link_modify_start<strong>" . LABEL_ID . "</strong> $row[id]$link_modify_end $check_part&nbsp;&nbsp;" .
        "<strong>" . LABEL_OWNER . ":</strong> $row[owner]&nbsp;&nbsp;<strong>" . LABEL_TYPE .
        ":</strong> $s_visib&nbsp;&nbsp;<strong>" . LABEL_HITS . ":</strong> $row[hits]</td>" .
        "</tr>" .
        "<tr><td class=\"table_sez\" align=\"LEFT\"><strong>" . LABEL_URL . ":</strong> $s_url</td></tr>" .
        "<tr><td class=\"table_sez\" align=\"LEFT\"><strong>" . LABEL_ALT . ":</strong> $s_alt</td></tr>" .
        "<tr><td class=\"table_sez\" align=\"LEFT\"><strong>" . LABEL_DESCRIPTION . ":</strong> $s_desc</td></tr>";
    } // _output_banner_row

    function _output_sizetype_selection ($id) {

    echo
        "<select class=\"insert_area\" size=\"1\" name=\"bannerList[sizetype]\" ".
        "onchange=\"document.forms.fshowbanners.resetpositionstatus.value=1; document.forms.fshowbanners.submit();\">\n";

    $dbquery = "SELECT * FROM " . THEBANNER_TABLE_SIZE;

    // note di contenuto per questa immagine
    $rowrs = $this->_tb_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_tb_connh->ErrorMsg());

    if (!$rowrs->RecordCount()) {

        // se non ci sono banner si costruisce una lista dei banner di default
        foreach ($this->_tb_defaultbannerlist as $currpair) {
        $dbquery = "INSERT INTO " . THEBANNER_TABLE_SIZE . " (w, h, type) VALUES (" . "'$currpair[0]', '$currpair[1]', 'default')";
        $this->_tb_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_tb_connh->ErrorMsg());
        } // foreach

        $dbquery = "SELECT * FROM " . THEBANNER_TABLE_SIZE;
        $rowrs = $this->_tb_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_tb_connh->ErrorMsg());
    }

    if ($rowrs->RecordCount() > 0) {
        while (!$rowrs->EOF) {
        $row = $rowrs->fields;
        $issel = $id == $row['id'] ? 'SELECTED' : '';
        echo "<option $issel value=\"$row[id]\">" . $row['w'] . 'x' . $row['h'] . "</option>\n";

                $rowrs->MoveNext();
            } // while
    } // if

    echo "</select>\n";
    } // _output_sizetype_selection

    function _output_visibility_selection ($oldval) {
    echo "<select class=\"insert_area\" size=\"1\" name=\"bannerList[visibility]\" onchange=\"document.forms.fshowbanners.submit();\">\n";
    $vis_type = array ('private', 'public');
    $label_list = array('private' => LABEL_BANNER_PRIVATE, 'public' => LABEL_BANNER_PUBLIC); 

    foreach ($vis_type as $currval) {
        $issel = $oldval == $currval ? 'SELECTED' : '';
        echo "<option $issel value=\"$currval\">" . $label_list[$currval] . "</option>\n";
    }
    echo "</select>\n";
    } // _output_visibility_selection

    function _output_owner_selection ($oldval) {

    $ischecked = $oldval ? 'CHECKED' : '';

    echo "<input class=\"insert_area\" $ischecked type=\"CHECKBOX\" name=\"bannerList[owner]\ value=\"1\" onclick=\"document.forms.fshowbanners.submit();\">\n";
    } // _output_owner_selection

    function _output_showlimit_selection ($oldval) {
    echo "<select class=\"insert_area\" size=\"1\" name=\"bannerList[showlimit]\" onchange=\"document.forms.fshowbanners.submit();\">\n";
    $limit_list = array ('1', '2', '3', '4', '5', '10', '15', '20', '30', '50');

    foreach ($limit_list as $currval) {
        $issel = $oldval == $currval ? 'SELECTED' : '';
        echo "<option $issel value=\"$currval\">" . $currval . "</option>\n";
    }
    $issel = !$oldval ? 'SELECTED' : '';
    echo "<option $issel value=\"0\">" . LABEL_ALL_BANNERS . "</option>\n";
    echo "</select>\n";
    } // _output_showlimit_selection



    function _output_prefs_vars ($bannerList) {
echo <<< END

<input type="HIDDEN" name="bannerList[sizetype]" value="$bannerList[sizetype]">
<input type="HIDDEN" name="bannerList[visibility]" value="$bannerList[visibility]">
<input type="HIDDEN" name="bannerList[position]" value="$bannerList[position]">
<input type="HIDDEN" name="bannerList[showlimit]" value="$bannerList[showlimit]">
<input type="HIDDEN" name="bannerList[owner]" value="$bannerList[owner]">
END;
    } // _output_prefs_vars

    function _get_group_list ($type) {

    if ($this->_tb_currentuser == THEBANNER_SUPERUSER)
        $where_clause = " WHERE sizetype = '" . $type . "'";
    else $where_clause = " WHERE sizetype = '" . $type . "' AND owner = '" . $this->_tb_currentuser . "' OR visibility = '" . "public" . "'";

    $dbquery =
        "SELECT COUNT(". THEBANNER_TABLE_RELATIONS . ".idrel) AS totbanner, " .
        "id, name, visibility, sizetype, owner" .
        " FROM " .
        THEBANNER_TABLE_GROUP . " LEFT JOIN " . THEBANNER_TABLE_RELATIONS . " ON id = idgroup " . $where_clause .
        " GROUP BY id DESC";

    $rowrs = $this->_tb_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_tb_connh->ErrorMsg());

    return $rowrs;
    } // _get_group_list

    function _get_size_list () {

    $size_list = array();

    $dbquery = "SELECT * FROM " . THEBANNER_TABLE_SIZE;

    $rowrs = $this->_tb_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_tb_connh->ErrorMsg());

    if ($rowrs->RecordCount() > 0) {
        while (!$rowrs->EOF) {
        $row = $rowrs->fields;
        $size_list[] = $row['w'] . 'x' . $row['h'];
                $rowrs->MoveNext();
            } // while
    } // if
        
    return $size_list;
    } // _get_size_list
        

    function _get_size_type ($w, $h) {

    $dbquery = "SELECT * FROM " . THEBANNER_TABLE_SIZE . " WHERE w = '" . $w . "' AND h = '" . $h . "'"; 
    $rowrs = $this->_tb_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_tb_connh->ErrorMsg());

    if ($rowrs->RecordCount() > 0) {
        return $rowrs->fields('id');
    }
    else return -1;
    } // _get_size_type
    

    function _get_size_from_type ($type, &$ww, &$hh) {

    $dbquery = "SELECT * FROM " . THEBANNER_TABLE_SIZE . " WHERE id = '" . $type . "'";
    $rowrs = $this->_tb_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_tb_connh->ErrorMsg());

    if ($rowrs->RecordCount() > 0) {
        $ww = $rowrs->fields('w');
        $hh = $rowrs->fields('h'); 
  
        return $ww . 'x' . $hh;
    }
    else return "UNKNOWN";
    } // _get_size_from_type

    function _insert_banner ($bi, $sizetype, $imgtype, &$random_suffix) {

    // generazione parte random del nome
    $charlist = '0123456789abcdefghijklmnopqrstuvwxyz';
    $random_suffix = '';
    $cmax = strlen($charlist) - 1;
    for ($i = 0; $i < 10; $i++)
        $random_suffix .= $charlist{rand(0, $cmax)};

    // toglobaloff
    $dbquery = "INSERT INTO " . THEBANNER_TABLE_LIST .
        " (alt, url, description, sizetype, imgtype, visibility, owner, random) " .
        " VALUES ('" . addslashes($bi[alt]) . "', '$bi[url]', '" . addslashes($bi[description]) . "', '$sizetype', '$imgtype', '$bi[visibility]', '$this->_tb_currentuser', '$random_suffix')";
 
    $this->_tb_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_tb_connh->ErrorMsg());

    return $this->_tb_connh->Insert_ID(); 
    }


    function _map_file_to_extension ($code) {
    $rext[-1] = 'UNKNOWN';
    $rext[1] = 'gif';
    $rext[2] = 'jpg';
    $rext[3] = 'png';
    $rext[4] = 'swf';
    $rext[13] = 'swf';
    
    $sres = $rext[$code];
    if (trim($sres) == '')
        $sres = $rext[-1];

    return $sres;
    }

    function _is_a_valid_groupname ($gname) {
    
    return ereg("^([[:alnum:]]{1,})$", $gname);
    } // _is_a_valid_groupname


    function _groupname_exists ($gname) {

    $dbquery =
        "SELECT id FROM " . THEBANNER_TABLE_GROUP . " WHERE name = '" . $gname . "' AND owner = '" . $this->_tb_currentuser . "'";

    $rowrs = $this->_tb_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_tb_connh->ErrorMsg());

    return ($rowrs->RecordCount() > 0);
    } // _groupname_exists

    
    function _create_new_group ($gname, $visibility, $type) {

    // qualche controllo
    if ($visibility != 'public' && $visibility != 'private')
        $visibility = 'private';

    $dbquery =
        "INSERT INTO " . THEBANNER_TABLE_GROUP .
        " (name, visibility, sizetype, owner) VALUES ('$gname', '$visibility', '$type', '$this->_tb_currentuser')";

    $this->_tb_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_tb_connh->ErrorMsg());


    return $this->_tb_connh->Insert_ID(); 
    } // _create_new_group


    function _add_banners_to_group ($groupid, $blist) {

    // qui si fa un po' di lavoro

    $nadded = 0;
    
    // si controlla di poter aggiungere a questo gruppo
    if (!$this->_has_group_write_permission($groupid, $gowner, $visibility, $gname)) {
        $this->_tb_last_error = ERR_BANNER_ADD_PERMISSION . " \"$gname\"";
        $this->_tb_error = true;
        return;
    }
    
    if (!count($blist)) {
        $this->_tb_last_error = ERR_NO_BANNER_TO_ADD;
        $this->_tb_error = true;
        return;
    }
    
    foreach ($blist as $bid) {

        if (!is_numeric($bid))
        continue;

        // se non c'e' gia' si aggiunge
        $dbquery = "SELECT idrel FROM " . THEBANNER_TABLE_RELATIONS . " WHERE idgroup = '" . $groupid . "' AND idbanner = '" . $bid . "'";
        $rowrs = $this->_tb_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_tb_connh->ErrorMsg());
        if (!$rowrs->RecordCount()) {
        $dbquery = "INSERT INTO " . THEBANNER_TABLE_RELATIONS . " (idgroup, idbanner) VALUES ('$groupid', '$bid')";
        $this->_tb_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_tb_connh->ErrorMsg());
        $nadded++;      
        } // if (!$rowrs

    } // foreach

    if (!$nadded) {
        if ($this->_tb_debug)
        $this->_out_debug_msg("Non si aggiunge nulla perche' i banner sono gia' presenti");
    }

    } // _add_banners_to_group


    function _remove_banner_from_group ($groupid, $bid) {

    $dbquery =
       "DELETE FROM " . THEBANNER_TABLE_RELATIONS .
        " WHERE idgroup = '" . $groupid . "' AND idbanner = '" . $bid . "'";

    $this->_tb_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_tb_connh->ErrorMsg());

    if ($this->_tb_debug)
        $this->_out_debug_msg("Numero di banner eliminati dal gruppo $groupid: " . $this->_tb_connh->Affected_Rows());

    } // _remove_banner_from_group

    function _remove_from_banner_list ($bannerRemove) {

    if (isset($bannerRemove) && is_array($bannerRemove) && count($bannerRemove)) {
        foreach ($bannerRemove as $bid) {
        if ($this->_has_banner_write_permission($bid, $imgtype, $random_suffix, $sizetype)) {

            $dbquery = "DELETE FROM " . THEBANNER_TABLE_LIST . " WHERE id='" . $bid . "'";
            $this->_tb_connh->Execute($dbquery) or
            die("ERROR: $dbquery<br />" . $this->_tb_connh->ErrorMsg());
            if ($this->_tb_debug && $this->_tb_connh->Affected_Rows())
            $this->_out_debug_msg ("Ho eliminato il banner avente id $bid");

            // si elimina fisicamente l'immagine
            $bannername =
            $this->_tb_bannerdir . '/' . $this->_get_size_from_type($sizetype, $ww, $hh) . '/' .
            $bid . '-' . $random_suffix . '.' .
            $this->_map_file_to_extension($imgtype);

            if (file_exists($bannername)) {
            if(!@unlink($bannername) && $this->_tb_debug)
                $this->_out_debug_msg("Non &Egrave; stato possibile rimuovere il file $bannername");

            } else if ($this->_tb_debug)
            $this->_out_debug_msg("Il file $bannername non esiste!");

            // e dai gruppi che eventualmente lo contengono
            $dbquery = "DELETE FROM " . THEBANNER_TABLE_RELATIONS . " WHERE idbanner = '" . $bid . "'";
            $this->_tb_connh->Execute($dbquery) or
            die("ERROR: $dbquery<br />" . $this->_tb_connh->ErrorMsg());
            if ($this->_tb_debug)
            $this->_out_debug_msg (
                "Il banner $bid eliminato da un numero di gruppi pari a " .
                $this->_tb_connh->Affected_Rows()
            );
        }
        else {
            $this->_tb_last_error = ERR_BANNER_DELETE_PERMISSION; 
            $this->_tb_error = true;
            return;
        }
        } // foreach
    }
    } // _remove_from_banner_list

    function _get_group_owner_visibility_name ($groupid, &$visibility, &$gname) {

    $gowner = '';
    $visibility = '';
    $gname = '';

    $dbquery = "SELECT name, owner, visibility FROM " . THEBANNER_TABLE_GROUP . " WHERE id = '" . $groupid . "'";

    $rowrs = $this->_tb_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_tb_connh->ErrorMsg());
    if ($rowrs->RecordCount() > 0) {
        $gowner = $rowrs->fields('owner');
        $visibility = $rowrs->fields('visibility');
        $gname = $rowrs->fields('name');
    }
    return $gowner;
    } // _get_grpup_owner


    function _delete_group ($groupid) {

    // cancellazione del gruppo

    $dbquery = "DELETE FROM " . THEBANNER_TABLE_GROUP . " WHERE id = '" . $groupid . "'";
    $rowrs = $this->_tb_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_tb_connh->ErrorMsg());
    
    if ($this->_tb_debug)
        $this->_out_debug_msg ("Ho eliminato il gruppo $groupid");

    // cancellazione di banner presenti nel gruppo

    if ($rowrs) {
        $dbquery = "DELETE FROM " . THEBANNER_TABLE_RELATIONS . " WHERE idgroup = '" . $groupid . "'";
        $this->_tb_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_tb_connh->ErrorMsg());
        if ($this->_tb_debug)
        $this->_out_debug_msg("Banner eliminati appartenenti al gruppo $groupid pari a " . $this->_tb_connh->Affected_Rows());

    }
    } // _delete_group


    function _set_group_visibility ($groupid, $visibility) {

    $dbquery = "UPDATE " . THEBANNER_TABLE_GROUP . " SET visibility = '" . $visibility . "' WHERE id = '" . $groupid . "'";
    $this->_tb_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_tb_connh->ErrorMsg());

    } // _set_group_visibility

    function _has_group_write_permission ($gid, &$gowner, &$visibility, &$gname) {

    $gowner = $this->_get_group_owner_visibility_name ($gid, $visibility, $gname);

    return (($gowner != '' && $gowner == $this->_tb_currentuser) ||
    $this->_tb_currentuser == THEBANNER_SUPERUSER);
    } // _has_group_write_permission

    function _has_banner_write_permission ($bid, &$imgtype, &$random_suffix, &$sizetype) {
    $imgtype = -1;
    
    $dbquery = "SELECT sizetype, imgtype, owner, random FROM " . THEBANNER_TABLE_LIST . " WHERE id='" . $bid . "'";

    $rowrs = $this->_tb_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_tb_connh->ErrorMsg());
    if ($rowrs->RecordCount() > 0) {
        $sizetype = $rowrs->fields('sizetype');
        $imgtype = $rowrs->fields('imgtype');
        $random_suffix = $rowrs->fields('random');
        if ($rowrs->fields('owner') == $this->_tb_currentuser ||
        $this->_tb_currentuser == THEBANNER_SUPERUSER)
        return 1;
    }
    return 0;
    } // _has_banner_write_permission


    function _banner_class_exists ($w, $h) {

    $dbquery = "SELECT id FROM " . THEBANNER_TABLE_SIZE . " WHERE w = '" . $w . "' AND h ='" . $h . "'";
    $rowrs = $this->_tb_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_tb_connh->ErrorMsg());

    return $rowrs->RecordCount();
    } // _banner_class_exists


    // original Written by flexer at cutephp dot com)

    function _remove_banner_dir($dir){

    if (!file_exists($dir))
        return;

    $current_dir = opendir($dir);

    while($entryname = readdir($current_dir)){
        if(is_dir("$dir/$entryname") and ($entryname != "." and $entryname!="..")){
        $this->_remove_banner_dir("${dir}/${entryname}");
        }
        else if ($entryname != "." and $entryname!=".."){
        unlink("${dir}/${entryname}");
        }
    } // while
    closedir($current_dir);
    rmdir(${dir});
    }

    function _out_debug_msg ($msg) {
    echo
        "<strong><span style=\"font-family:Verdana;font-size:12;color:red\">DEBUG: </span></strong><span style=\"font-family:Verdana;font-size:12>" . $msg . "</span>" .
    // . " [" . __FILE__ . ", line: " . __LINE__ . "]" .
        "<strong><span style=\"color:red\"> :GUBED</span></strong><br />\n";
    } // _out_debug_msg


    function handleUpload($bannerInfo, &$bannerList) {

    // vediamo se il nome c'e'
        if (trim($_FILES["upfile"]["name"]) == '') {
        $this->_tb_last_error = ERR_NO_UPLOADED_FILE;
        $this->_tb_error = true;
        return;
    }

    if (@is_uploaded_file($_FILES["upfile"]["tmp_name"])) {

        $size = @getimagesize($_FILES["upfile"]["tmp_name"]);

        // un controllo sul tipo di immagine accettato
        
        if ($size[2] < 1 || ($size[2] > 4 && $size[2] != 13)) {
        $this->_tb_last_error = ERR_UPLOADED_FILE_FORMAT;
        $this->_tb_error = true;
        return;
        }       

        if ($size == false) {
        $this->_tb_last_error = ERR_UNKNOWN_IMAGE_FORMAT;
        $this->_tb_error = true;
        return;
        }

        $currdim = $size[0] . 'x' . $size[1];

        if (!in_array($currdim, $this->_get_size_list())) {
        $this->_tb_last_error =
            $currdim . ": " . ERR_BANNER_SIZE;
        $thid->_tb_error_cose = ERR_TB_CODE_WRONG_SIZE;
        $this->_tb_error = true;
        return;
        }

        $sizetype = $this->_get_size_type($size[0], $size[1]);
        if ($sizetype == -1) {
        $this->_tb_last_error = ERR_UNKNOWN_SIZE_FORMAT . " " . "$size[0]x$size[1]";
            $this->_tb_error = true;
        return;
        }

        $file_ext = $this->_map_file_to_extension($size[2]);

        $id_last_banner = $this->_insert_banner($bannerInfo, $sizetype, $size[2], $random_suffix);

        $banner_type_dir = $this->_tb_bannerdir . '/' . $size[0] . 'x' . $size[1];

        if (!file_exists($banner_type_dir))
        if (!@mkdir($banner_type_dir, 0700)) {
            $this->tb_last_error = ERR_DIRECTORY_CREATE . " \"" .  $banner_type_dir . "\"";
            $this->tb_error = true;
            return;
        }
        $dest_file = $banner_type_dir . '/' . $id_last_banner . '-' . $random_suffix . '.' . $file_ext;

        if (!@move_uploaded_file($_FILES["upfile"]["tmp_name"], $dest_file)) {
        $this->_tb_last_error = ERR_ULOADED_FILE_MOVE . " ($dest_file)";
        $this->_tb_error = true;

        // si toglie la relativa entrata dal database
        $this->_remove_from_banner_list(array($id_last_banner));
        return;
        }
        // meglio stare nelle impostazioni dell'ultimo upload
        $bannerList['sizetype'] = $sizetype;
        $bannerList['visibility'] = $bannerInfo['visibility'];
    }
    else {
        $this->_tb_last_error =
        ERR_UPLOAD_FILE_FAILED . " " . $_FILES["upfile"]["name"] .
        " (" . ERR_UPLOAD_FILE_SIZE . " " . $this->_tb_maxsize . " bytes)";
        $this->_tb_error = true;
        return -1;
    }

    return 1;
    } // handleUpload


    function handleAdding ($bannerList, $bannerAdd) {

    // creazione di un nuovo gruppo e aggiunta dei banner
    if ($bannerList['radio_mode'] == 'create_new_group') {

        if (trim($bannerList['new_group_name']) == '') {
        $this->_tb_last_error = ERR_BANNER_GROUP_MISSING_NAME;
        $this->_tb_error = true;
        return;
        }

        if (!$this->_is_a_valid_groupname($bannerList['new_group_name'])) {
        $this->_tb_last_error =
            "\"" . $bannerList['new_group_name'] . "\"" . " " . ERR_BANNER_GROUP_INVALID_NAME;
        $this->_tb_error = true;
        return;
        }

        if ($this->_groupname_exists($bannerList['new_group_name'])) {
        $this->_tb_last_error =
            ERR_BANNER_GROUP_EXISTS . ": \"" . $bannerList['new_group_name'] . "\"";
        $this->_tb_error = true;
        return;
        }
        
        $groupid = $this->_create_new_group ($bannerList['new_group_name'], $bannerList['group_visibility'], $bannerList['sizetype']);

    }
    // aggiunta di un gruppo preesistente
    else if ($bannerList['radio_mode'] == 'add_to_group') {
        $groupid = $bannerList['selected_group'];

        if (!isset($groupid) || !$groupid) {
        $this->_tb_last_error = ERR_BANNER_GROUP_UNSELECTED;
        $this->_tb_error = true;
        return;
        }
    }
    else if ($bannerList['radio_mode'] == 'remove_from_banner_list') {
        $this->_remove_from_banner_list ($bannerAdd); 
        return;
    }

    $this->_add_banners_to_group ($groupid, $bannerAdd);


    } // handleAdding

    function handleRemoving ($gid, $bannerRemove) {
   
    // si verifica se possiamo interbenire sul gruppo

    if (!$this->_has_group_write_permission ($gid, $gowner, $visibility, $gname)) {
        $this->_tb_last_error = ERR_BANNER_GROUP_MODIFY_PERMISSION . " \"" . $gname . "\"";
        $this->_tb_error = true;
        return;
    }

    $nremoved = 0;

    if (isset($bannerRemove) && is_array($bannerRemove) && count($bannerRemove)) {
        foreach ($bannerRemove as $bid) {
        if ($this->_tb_debug)
            $this->_out_debug_msg("Rimuovi il banner $bid dal gruppo $gid");
        $this->_remove_banner_from_group ($gid, $bid);
        $nremoved++;
        }
    }
    else {
        $this->_tb_last_error = ERR_BANNER_UNSELECTED;
        $this->_tb_error = true;
        return;
    }

    } // handleRemoving


    function handleGroupEditing ($bGroupVisibility, $bGroupDelete, $bGroupShow, $bannerList) {


    // eventuale cancellazione di gruppi
    if (isset($bGroupDelete) && is_array($bGroupDelete) && count($bGroupDelete)) {
        foreach ($bGroupDelete as $gid) {
        if (is_numeric($gid)) {
            if ($this->_has_group_write_permission($gid, $gowner, $visibility, $gname))
            $this->_delete_group($gid);
        }
        } // foreach
    reset($bGroupDelete);
    }
   
    // eventuale modifica della visibilita' pubblica o privata
    if (isset($bGroupVisibility) && is_array($bGroupVisibility) && count($bGroupVisibility)) {
       while (list($gid, $v) = each($bGroupVisibility)) { 
        if (is_numeric($gid)) {
            if (isset($bGroupDelete) && is_array($bGroupDelete) && in_array($gid, $bGroupDelete)) {
            if ($this->_tb_debug)
                $this->_out_debug_msg("Non si prende in considerazione il gruppo $gid perche' appena cancellato!");
            }
            else {
            if ($this->_has_group_write_permission($gid, $gowner, $visibility, $gname))
                if ($visibility != '' && $v != $visibility) {
                if ($this->_tb_debug)
                    $this->_out_debug_msg("La visibilita del gruppo $gid &Egrave; cambiata: la setto a $v");
                $this->_set_group_visibility($gid, $v);
                }
            }
        }
        } // while
    }

    // mostra la lista dei banner di questo gruppo
    if (isset($bGroupShow) && is_array($bGroupShow) && count($bGroupShow)) {
        list ($gid, $v) = each($bGroupShow);
        $this->showGroupInfo($gid, $bannerList);
    }

    } // handleGroupEditing

    function handleBannerModify ($bid, $bannerModify, $bannerList) {

    if (!$this->_has_banner_write_permission ($bid, $imgtype, $random_suffix, $sizetype)) {
        $this->_tb_last_error = ERR_BANNER_MODIFY_PERMISSION;
        $this->_tb_error = true;
        return;
    }

    $banner_type_dir = $this->_tb_bannerdir . "/" . $this->_get_size_from_type ($bannerList['sizetype'], $ww, $hh);


    // applica le eventuali modifiche
    if (isset($bannerModify) && is_array ($bannerModify) && count ($bannerModify) && isset($bannerModify['bBannerModify'])) {

	// togloblaoff
        $dbquery = "UPDATE " . THEBANNER_TABLE_LIST . " SET" .
        " alt = '" . addslashes($bannerModify['alt']) . "', " .
        " url = '" .  $bannerModify['url'] . "', " .
        " description = '" . addslashes($bannerModify['description']) . "', " .
        " visibility = '" .  $bannerModify['visibility'] . "'" .
        " WHERE id ='" . $bid . "'";

        $this->_tb_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_tb_connh->ErrorMsg());

        if ($this->_tb_connh->Affected_Rows() == 1)
        $this->outMessage(MSG_CHANGES_SAVED);
    }

    $dbquery = "SELECT * FROM " . THEBANNER_TABLE_LIST . " WHERE id = '" . $bid . "'";
    $rowrs = $this->_tb_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_tb_connh->ErrorMsg());

    if ($rowrs->RecordCount() > 0)
        $row = $rowrs->fields;
    else {
        $this->_tb_last_error = ERR_BANNER_ID_NOT_FOUND . " \"" . $bid . "\"";
        $this->_tb_error = true;
        return;
    }

    // stampa del banner per modifica
echo <<< END
    <form name="fbannermodify" action="$_SERVER[PHP_SELF]" method="POST">
    <input type="HIDDEN" name="bannermodify" value="$bid">
END;


    $modify_button =
    "&nbsp;&nbsp;&nbsp;" .                                                                                          
    "<input class=\"button_in\" type=\"SUBMIT\" name=\"bannerModify[bBannerModify]\" value=\"" . BUTTON_SAVE_PREFERENCES . "\">";

    $this->_output_prefs_vars($bannerList);

    $l_banner_preferences_set = LABEL_BANNER_PREFERENCES_SET; 
    $l_go_to_main_panel = LABEL_GO_TO_MAIN_PANEL;

echo <<< END
<table class="table_border" width="
END;
include("include/dim_all.inc.php");
echo <<< END
" align="CENTER" cellpadding="3" cellspacing="1" border="0">
<tr><td class="table_tit" align="CENTER" colspan="2">$l_banner_preferences_set $bid</td></tr>
END;

    $this->_get_size_from_type($bannerList['sizetype'], $ww, $hh);

    $this->_output_banner_row($row, THEBANNER_ACTION_MODIFY, $banner_type_dir, $ww, $hh);

echo <<< END
<tr>
<td colspan="2" class="button_out" align="CENTER">
<input class="button_in" type="SUBMIT" name="bTopanel" value="$l_go_to_main_panel">
$modify_button
</td>
</tr>
END;
    echo "</table></form>\n";

    } // handleBannerModify


    function handleSizeModify ($bannerList, $sizeNew, $sizeRemove) {

    if ($this->_tb_currentuser != THEBANNER_SUPERUSER) {
        $this->_tb_last_error = ERR_BANNER_SIZE_EDIT;
        $this->_tb_error = true;
        return;
    }

    // qui c'erano diverse righe per la modifica delle dimensioni della classe banner
    // sono state eliminate
    // non si permette la modifica perch&eacute; comunque si arebbe poi dovuto elimare tutta la base dati
    // di banner su file system (dimensioni non corrispondenti)

    // se ci sono nuove aggiunte
    if (isset($sizeNew) && is_array($sizeNew) && count($sizeNew)) {
        $w = $sizeNew['w'];
        $h = $sizeNew['h'];

        if (trim($w) != '' && trim($h) != '') {
        if (is_numeric($w) && is_numeric ($h)) {

            // se questa classe non c'e' digia'....
            if ($this->_banner_class_exists($w, $h)) {
            $this->_tb_last_error = $w . " x " . $h . ": " . ERR_BANNER_SIZE_CLASS_EXISTS;
            $this->_tb_error = true;
            } else {
            $dbquery = "INSERT INTO " . THEBANNER_TABLE_SIZE . " (w, h, type) VALUES (" .
                "'$w', '$h', 'custom')";
            $this->_tb_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_tb_connh->ErrorMsg());
            }

        } else {
            $this->_tb_last_error = $w . " x " . $h . ": " . ERR_BANNER_SIZE_INVALID;
            $this->_tb_error = true;
        }
        }

    }
    // stampa di eventuali errori
    $this->outError();


    $nremoved = 0;
    // se ci sono dimensioni da eliminare
    if (isset($sizeRemove) && is_array($sizeRemove) && count($sizeRemove)) {
        foreach ($sizeRemove as $currid) {
        
        // si prendono le dimensioni correnti di 'sto gruppo
        $dbquery = "SELECT w,h FROM " . THEBANNER_TABLE_SIZE . " WHERE id ='" . $currid . "'";
        $rowrs = $this->_tb_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_tb_connh->ErrorMsg());
        if ($rowrs->RecordCount()) {
            $row = $rowrs->fields;
            $t_size_w = $row['w'];
            $t_size_h = $row['h'];
        }
        else {
            $t_size_w = '';
            $t_size_h = '';
        }

        $dbquery = "DELETE FROM " . THEBANNER_TABLE_SIZE . " WHERE id = '" . $currid . "' AND type = 'custom'";
        $this->_tb_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_tb_connh->ErrorMsg());
        $nremoved += $this->_tb_connh->Affected_Rows();
        
        $dbquery = "DELETE FROM " . THEBANNER_TABLE_LIST . " WHERE sizetype = '" . $currid . "'";
        $this->_tb_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_tb_connh->ErrorMsg());
        if ($this->_tb_debug)
            $this->_out_debug_msg("Numero di banner aventi sizetype $currid eliminati dalla lista: " .
            $this->_tb_connh->Affected_Rows());
        
        // prima si tiene traccia dei gruppi che verranno cancellati
        $dbquery = "SELECT id FROM " . THEBANNER_TABLE_GROUP . " WHERE sizetype = '" . $currid . "'";
        $rowrs = $this->_tb_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_tb_connh->ErrorMsg());

        if ($rowrs->RecordCount()) {

            $dbquery = "DELETE FROM " . THEBANNER_TABLE_GROUP . " WHERE sizetype = '" . $currid . "'";
            $this->_tb_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_tb_connh->ErrorMsg());
            if ($this->_tb_debug)
            $this->_out_debug_msg("Numero di gruppi aventi sizetype $currid eliminati dalla lista gruppi: " .
                $this->_tb_connh->Affected_Rows());

            while (!$rowrs->EOF) {
            $row = $rowrs->fields;
            $dbquery = "DELETE FROM " . THEBANNER_TABLE_RELATIONS . " WHERE idgroup = '" . $row['id'] . "'";
            $this->_tb_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_tb_connh->ErrorMsg());
            if ($this->_tb_debug)
                $this->_out_debug_msg("Gruppo $row[id]: numero di relazioni elimnate: " .
                $this->_tb_connh->Affected_Rows());
            $rowrs->MoveNext();
            }

        } // ($rowrs->RecordCount()
        
        // elimazione dei banner e sizetype dal filesystem
        if ($t_size_w != '' && $t_size_h != '' && is_numeric($t_size_w) && is_numeric($t_size_h)) {
            $bannerdir = $this->_tb_bannerdir . '/' . $t_size_w . 'x' . $t_size_h;

            if ($this->_tb_debug)
            $this->_out_debug_msg("Eliminazione della directory " . $bannerdir);

            if (file_exists($bannerdir))
            $this->_remove_banner_dir($bannerdir);

            else if ($this->_tb_debug)
            $this->_out_debug_msg("Non esiste la directory $bannerdir");

        }
        else if ($this->_tb_debug)
            $this->_out_debug_msg("Non si elimina su filesystem poiche' paion non buone le dimensioni $t_size_w x $t_size_h");

        } // foreach
    }

    // stampa di eventuali errori
    $this->outError();

    if ($nremoved)
        $this->outMessage(MSG_N_REMOVED_CLASSES . ": " . $nremoved);


    // si rileggono le modifiche

    $dbquery = "SELECT * FROM " . THEBANNER_TABLE_SIZE . " ORDER BY id DESC";
    $rowrs = $this->_tb_connh->Execute($dbquery) or die("ERROR: $dbquery<br />" . $this->_tb_connh->ErrorMsg());

    if ($rowrs->RecordCount() > 0) {


echo <<< END
    <form name="fsizemodify" action="$_SERVER[PHP_SELF]" method="POST">
    <input type="hidden" name="sizemodify" value="ok" />
END;


    $modify_button =
        "&nbsp;&nbsp;&nbsp;" .                                                                                          
        "<input class=\"button_in\" type=\"SUBMIT\" name=\"bannerSizeModify[bSizeModify]\" value=\"" .
        BUTTON_APPLY_CHANGES .
        "\">";

    $this->_output_prefs_vars($bannerList);

echo <<< END
<table class="table_border" width="600" align="CENTER" cellpadding="3" cellspacing="1" border="0">
<tr><td class="table_tit" align="CENTER" colspan="4">Modifica delle classi di banner</td></tr>
<tr>
<th class="table_id" width="100" align="CENTER">ID</th>
<th class="table_tit" width="200" align="CENTER">LARGHEZZA</th>
<th class="table_tit" width="200" align="CENTER">ALTEZZA</th>
<th class="table_tit" width="100" align="CENTER">ELIMINA</th>
</tr>
END;

    
    while (!$rowrs->EOF) {
        $row = $rowrs->fields;

        if ($row['type'] == 'custom') {
        $s_class = "table_tit";
        $s_w = $row['w'];
        $s_h = $row['h'];
        $s_elimina = "<input class=\"insert_area\" type=\"CHECKBOX\" name=\"sizeRemove[]\" value=\"" . $row['id'] . "\">";

        }
        else {
        $s_class = "table_id";
        $s_w = $row['w'];
        $s_h = $row['h'];
        $s_elimina = ' --- ';
        }

        echo
        "<tr>\n" .
        "<td class=\"$s_class\" align=\"CENTER\">$row[id]</td>" .
        "<td class=\"$s_class\" align=\"CENTER\">$s_w</td>" .
        "<td class=\"$s_class\" align=\"CENTER\">$s_h</td>" .
        "<td class=\"$s_class\" align=\"CENTER\">$s_elimina</td>" .
        "</tr>\n";

        $rowrs->MoveNext();
    } // while

    echo
        "<tr>\n<td class=\"table_tit\" colspan=\"4\" align=\"CENTER\">" . LABEL_BANNER_SIZE_CLASS_NEW . "</td></tr>\n" .
        "<tr>\n" .
        "<td colspan=\"4\" class=\"table_sez\" align=\"CENTER\">" .
        LABEL_BANNER_SIZE_WIDTH . ": " . "<input class=\"insert_area\" type=\"TEXT\" size=\"5\" name=\"sizeNew[w]\">&nbsp;&nbsp;" .
        LABEL_BANNER_SIZE_HEIGHT . ": " . "<input class=\"insert_area\" type=\"TEXT\" size=\"5\" name=\"sizeNew[h]\">" .
        "</td>" .
        "</tr>\n";


    $l_go_to_main_panel = LABEL_GO_TO_MAIN_PANEL;


echo <<< END
<tr>
<td colspan="4" class="button_out" align="CENTER">
<input class="button_in" type="SUBMIT" name="bTopanel" value="$l_go_to_main_panel">
$modify_button
</td>
</tr>
END;


    } // if ($rowrs->RecordCount

    echo "</table>\n</form>\n<br />\n";

    $this->outMessage(MSG_BANNER_SIZE_WARNING . "<br />" . MSG_BANNER_CLASSES_MODIFY); 

    } // handleSizeModify


    function outError() {

    if ($this->_tb_error == true) {
        $this->_tb_error = false;
        if ($this->_tb_last_error != '')
        $errmsg = $this->_tb_last_error;
        else
        $errmsg = "UNKNOWN ERROR";

        if ($this->_tb_error_code == ERR_TB_CODE_WRONG_SIZE) {
        $size_list = $this->_get_size_list();
        if (!count($size_list))
            $notemsg = ERR_NO_SIZE_LIST;
        else {
            while (list($k, $v) = each($size_list))
            $notemsg .= $notemsg . ' ' . $v;
            $notemsg = MSG_SIZE_LIST . " " . $notemsg;
        }
        }
        else $notemsg = '';         

        echo "<br /><div align=\"CENTER\" class=\"insert_message\"><strong>" . $errmsg . "<br />" . $notemsg . "</strong></div><br /><br />";

        $this->_tb_error_code = 0;
        $this->_tb_last_error = '';
    }
    } // outError


    function outMessage ($msg) {
    echo
        "<div class=\"insert_message\" align=\"CENTER\"><strong>" .
        $msg .
        "</strong></div>\n";
    }

} // class


?>
